var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { AbstractStreamingSyncImplementation, LockType } from '@journeyapps/powersync-sdk-common';
export class WebStreamingSyncImplementation extends AbstractStreamingSyncImplementation {
    constructor(options) {
        // Super will store and provide default values for options
        super(options);
    }
    get webOptions() {
        return this.options;
    }
    obtainLock(lockOptions) {
        const identifier = `streaming-sync-${lockOptions.type}-${this.webOptions.workerIdentifier}`;
        lockOptions.type == LockType.SYNC && console.debug('requesting lock for ', identifier);
        return navigator.locks.request(identifier, { signal: lockOptions.signal }, () => __awaiter(this, void 0, void 0, function* () {
            return new Promise((resolve, reject) => {
                var _a;
                // TODO, the fetch and ndjson streams don't work well with being aborted via a signal
                // Currently there is a "DOMException: BodyStreamBuffer was aborted" error that is
                // thrown when the signal is aborted, but this error does not seem to be catchable
                (_a = lockOptions.signal) === null || _a === void 0 ? void 0 : _a.addEventListener('abort', () => {
                    reject(new Error('Abort signal received'));
                });
                lockOptions.callback().then(resolve).catch(reject);
            });
        }));
    }
}
//# sourceMappingURL=WebStreamingSyncImplementation.js.map